﻿Type=Class
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'''
' Alarm Files;
' Alarm (Class)			 - Helper class for database connection and other stuff related to alarm
' AlarmService (Service) - will handle alarm voice, vibration and notification, starting activity, etc
'
Sub Class_Globals
	Private con As SQL
'	Public  myAlarmTime As Long = 0
'	
'	Public  myNextAlarmTime As Long = 0
	
	Public sdcardEnabled As Boolean

	Private rp As RuntimePermissions
	
	
End Sub


' Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	dbOpen
End Sub

Private Sub dbOpen() As Boolean
	
	Dim directory   As String
	
	If File.ExternalWritable  Then 
		directory =   rp.GetSafeDirDefaultExternal("") ' File.DirDefaultExternal
	Else 
		directory = File.DirInternal
	End If
	
	' check if database exist
	If File.Exists(directory, "alarms.db") = False Then
		' copy it to writable location
		File.Copy(File.DirAssets,"alarms.db",directory, "alarms.db")
	End If
	' initialize database connection
	con.Initialize(directory,"alarms.db", False)	
	
	If con.IsInitialized = False Then
		ToastMessageShow("Error openning database!", False)		
	End If
	Return con.IsInitialized
End Sub


public Sub SetDateTimeFormat(toDefault As Boolean)
	If toDefault = False Then
		DateTime.DateFormat = "dd/MM"
		DateTime.TimeFormat = "HH:mm"
	Else
		DateTime.DateFormat = DateTime.DeviceDefaultDateFormat
		DateTime.TimeFormat = DateTime.DeviceDefaultTimeFormat	
	End If
End Sub

 
public Sub Now() As Long
	Dim time As Long = DateTime.Now
	Return DateUtils.SetDateAndTime(DateTime.GetYear(time), DateTime.GetMonth(time), DateTime.GetDayOfMonth(time), DateTime.GetHour(time), DateTime.GetMinute(time), 0)	
End Sub


public Sub GetTodaysAlarm(date As Long) As Map	
	
		Dim data As Map
		data.Initialize
	
	If dbOpen = False Then
		ToastMessageShow("Error openning database!", False)
		Return Null
	End If
	
	SetDateTimeFormat(False)
	
	Dim dt As String = DateTime.Date(date)
	
	Dim query As String = "SELECT * FROM tripoli WHERE dte = '" & dt &  "'"
	Dim rec As Cursor = con.ExecQuery(query)

	If rec.RowCount = 1 Then
		rec.Position = 0
		For i = 1 To rec.ColumnCount - 1
			Dim colName As String = rec.GetColumnName(i)
			data.Put(colName, rec.GetString(colName))
		Next
	End If
	con.Close	
	
	Return data
	
	
End Sub

Public Sub IsAlarmTime() As Boolean	
	
	Dim YesAlarmTime As Boolean = False 
	
	
	Dim data As Map = GetTodaysAlarm(Now )
	
		SetDateTimeFormat(False)	

		For i = 0 To data.Size - 1		
			Dim dbAlarmTime As Long = DateTime.TimeParse(data.GetValueAt(i)) ' gets today date with your time =data.GetValueAt(i)
			Dim nowTime As Long = Now
			
			Log(DateTime.Date(nowTime) & " " & DateTime.Time(nowTime))
			
				If dbAlarmTime = nowTime  Then
					YesAlarmTime = True
					'myAlarmTime = dbAlarmTime
				End If

'				If dbAlarmTime >= nowTime  Then
'					myNextAlarmTime = dbAlarmTime
'				End If
'
				
		Next
		
	SetDateTimeFormat(True)	
	
	If YesAlarmTime =True Then
		Return True
	Else
		Return False
	End If
	
	
	
	
End Sub

Public Sub GetAlarmTimeString(Ticks As Long) As String 
	Dim data As String = ""
	SetDateTimeFormat(False)
	data = DateTime.Time(Ticks)
	SetDateTimeFormat(True)
	Return data
End Sub

' Get Human Readable value of alarm
Public Sub GetAlarmDateString(Ticks As Long) As String 
	Dim data As String = ""
	SetDateTimeFormat(False)
	data = DateTime.Date(Ticks)
	SetDateTimeFormat(True)
	Return data
End Sub


 
public Sub PrintAlarmDateTime(Next_Alarm As Long,Done As String) 'Ready_Alarm  As Long,
	
	SetDateTimeFormat(False)

	Log("Print Alarm Date Time :" & DateTime.Time(Next_Alarm) & "  Print Alarm Date Time :" & DateTime.Date(Next_Alarm) )
	Dim myPrayAlarm As String ="Done : " & Done & " ||Next Alarm: " &  DateTime.Time(Next_Alarm)  & " - " & "Date: " & DateTime.Date(Next_Alarm) & " || Time Now: " & DateTime.Time(DateTime.now) 
	
	Dim NewLine As String
	NewLine = myPrayAlarm
	Dim Writer As TextWriter
	
	Dim directory   As String
	
	If File.ExternalWritable Then 
		directory = rp.GetSafeDirDefaultExternal("") ' File.DirDefaultExternal 
	Else 
		directory = File.DirInternal
	End If


'	If File.Exists(File.DirDefaultExternal,"Allalarms.txt")= True Then
		Writer.Initialize(File.OpenOutput(directory,"Allalarms.txt",True))
		Writer.WriteLine(NewLine)
		Writer.Close
			
'	End If 
	
		SetDateTimeFormat(True)


End Sub


Sub SetExactAndAllowWhileIdle (Time As Long, ServiceName As String)
   Dim p As Phone
   If p.SdkVersion < 23 Then
     StartServiceAtExact(ServiceName, Time, True)
   Else
     Dim in As Intent
     in.Initialize("", "")
     in.SetComponent(Application.PackageName & "/." &  ServiceName.ToLowerCase)
     Dim ctxt As JavaObject
     ctxt.InitializeContext
     Dim am As JavaObject = ctxt.RunMethod("getSystemService", Array("alarm"))
     Dim pi As JavaObject
     pi = pi.InitializeStatic("android.app.PendingIntent").RunMethod("getService", _
       Array(ctxt, 1, in, 134217728))
     am.RunMethod("setExactAndAllowWhileIdle", Array(0, Time, pi))
   End If
End Sub


Public Sub PutAlarmTimesInDoubleArray() As Double()
		
		' 
		Dim alarm1,alarm2,alarm3,alarm4,alarm5,alarm6,alarm7 As String		' variables to save every alarm time Hour & Minutes
		Dim alarm1H,alarm2H,alarm3H,alarm4H,alarm5H,alarm6H,alarm7H As String   ' variables to save every alarm time just Hour
		Dim alarm1M,alarm2M,alarm3M,alarm4M,alarm5M,alarm6M,alarm7M As String   ' variables to save every alarm time just Minutes    

 		
		
		Dim AlarmsInDouble(7) As Double   ' an array to save all 7 alarms into double values
 
		'Dim alarmInfo As Alarm
	
		' map object to get today alarms 
		Dim Alarms As Map = GetTodaysAlarm(Now)

		' get alarm time from map object, you can also use alarms.Get("a1") to access columns	
	  	 alarm1 = Alarms.Get("alarm1")
		 alarm2 = Alarms.Get("alarm2")  
		 alarm3 = Alarms.Get("alarm3")  
		 alarm4 = Alarms.Get("alarm4")  
		 alarm5 = Alarms.Get("alarm5")  
		 alarm6 = Alarms.Get("alarm6")  
		 alarm7 = Alarms.Get("alarm7")  

		'  ********************** Alarm 1 *********************************************
		
		alarm1H =alarm1.Trim.SubString2(0,2)  	' split the hour from alarm1
		alarm1M=alarm1.Trim.SubString2(3,5) 	' split the minutes from alarm1

		Dim alarm1HVal , alarm1MVal As Int		
		alarm1HVal = alarm1H
		alarm1MVal = alarm1M
		AlarmsInDouble(0) = alarm1HVal + (alarm1MVal/60)   ' save the first alarm in double value

		'  ********************** Alarm 2 *********************************************
		
		alarm2H =alarm2.Trim.SubString2(0,2)  	' split the hour from alarm2
		alarm2M=alarm2.Trim.SubString2(3,5) 	' split the minutes from alarm2

		Dim alarm2HVal , alarm2MVal As Int		
		alarm2HVal = alarm2H
		alarm2MVal = alarm2M
		AlarmsInDouble(1) = alarm2HVal + (alarm2MVal/60)   ' save the second alarm in double value
		
		
		'  ********************** Alarm 3 *********************************************
		
		alarm3H =alarm3.Trim.SubString2(0,2)  	' split the hour from alarm3
		alarm3M=alarm3.Trim.SubString2(3,5) 	' split the minutes from alarm3

		Dim alarm3HVal , alarm3MVal As Int		
		alarm3HVal = alarm3H
		alarm3MVal = alarm3M
		AlarmsInDouble(2) = alarm3HVal + (alarm3MVal/60)   ' save the third alarm in double value
		
		'  ********************** Alarm 4 *********************************************
		
		alarm4H =alarm4.Trim.SubString2(0,2)  	' split the hour from alarm4
		alarm4M=alarm4.Trim.SubString2(3,5) 	' split the minutes from alarm4

		Dim alarm4HVal , alarm4MVal As Int		
		alarm4HVal = alarm4H
		alarm4MVal = alarm4M
		AlarmsInDouble(3) = alarm4HVal + (alarm4MVal/60)   ' save the fourth alarm in double value
		
		'  ********************** Alarm 5 *********************************************
		
		alarm5H =alarm5.Trim.SubString2(0,2)  	' split the hour from alarm5
		alarm5M=alarm5.Trim.SubString2(3,5) 	' split the minutes from alarm5

		Dim alarm5HVal , alarm5MVal As Int		
		alarm5HVal = alarm5H
		alarm5MVal = alarm5M
		AlarmsInDouble(4) = alarm5HVal + (alarm5MVal/60)   ' save the fifth alarm in double value

		'  ********************** Alarm 6 *********************************************
		
		alarm6H =alarm6.Trim.SubString2(0,2)  	' split the hour from alarm6
		alarm6M=alarm6.Trim.SubString2(3,5) 	' split the minutes from alarm6

		Dim alarm6HVal , alarm6MVal As Int		
		alarm6HVal = alarm6H
		alarm6MVal = alarm6M
		AlarmsInDouble(5) = alarm6HVal + (alarm6MVal/60)   ' save the sixth alarm in double value

		'  ********************** Alarm 7 *********************************************
		
		alarm7H =alarm7.Trim.SubString2(0,2)  	' split the hour from alarm7
		alarm7M=alarm7.Trim.SubString2(3,5) 	' split the minutes from alarm7

		Dim alarm7HVal , alarm7MVal As Int		
		alarm7HVal = alarm7H
		alarm7MVal = alarm7M
		AlarmsInDouble(6) = alarm7HVal + (alarm7MVal/60)   ' save the seventh alarm in double value


	Return AlarmsInDouble


End Sub



Sub FindNextTime(Times As List) As Long
   Times.Sort(True)
   For Each st As Double In Times
     If SetHours(st) > DateTime.Now Then
       Return SetHours(st)
     End If
   Next
   Return DateTime.Add(SetHours(Times.Get(0)), 0, 0, 1)
End Sub

Sub SetHours(st As Double) As Long
  Dim hours As Int = Floor(st)
  Dim minutes As Int = Round(60 * (st - hours))
  Return DateUtils.SetDateAndTime(DateTime.GetYear(DateTime.Now), _
  DateTime.GetMonth(DateTime.Now), DateTime.GetDayOfMonth(DateTime.Now), hours, minutes, 0)
End Sub




